<?php

class Whizzie {

	public function __construct() {
		$this->init();
	}

	public function init()
	{
	
	}

	public static function halloween_store_setup_widgets(){

	$halloween_store_product_image_gallery = array();
	$halloween_store_product_ids = array();

	$halloween_store_product_category= array(
		'Products'       => array(
			'Boo Tique',
			'Ghostly Glow',
			'Haunted Haven',
			'Midnight Howl',
			'Pumpkin Pop',
		),
	);
	$halloween_store_k = 1;
	foreach ( $halloween_store_product_category as $halloween_store_product_cats => $halloween_store_products_name ) { 
	// Insert porduct cats Start
	$content = 'This is sample product category';
	$halloween_store_parent_category	=	wp_insert_term(
	$halloween_store_product_cats, // the term
	'product_cat', // the taxonomy
		array(
		'description'=> $content,
		'slug' => str_replace( ' ', '-', $halloween_store_product_cats)
		)
	);

// -------------- create subcategory END -----------------

	$halloween_store_n=1;
	// create Product START
	foreach ( $halloween_store_products_name as $key => $halloween_store_product_title ) {
	$content = '
		<div class="main_content">
		<p>Lorem Ipsum is simply dummy text of the printing and typesetting industry. Lorem Ipsum has been the industry\'s standard dummy text ever since the 1500s, when an unknown printer took a galley of type and scrambled it to make a type specimen book.</p>
		</div>';

	// Create post object
	$halloween_store_my_post = array(
		'post_title'    => wp_strip_all_tags( $halloween_store_product_title ),
		'post_content'  => $content,
		'post_status'   => 'publish',
		'post_type'     => 'product',
		'post_category' => [$halloween_store_parent_category['term_id']]
	);

	// Insert the post into the database

	$halloween_store_uqpost_id = wp_insert_post($halloween_store_my_post);
	wp_set_object_terms( $halloween_store_uqpost_id, str_replace( ' ', '-', $halloween_store_product_cats), 'product_cat', true );

	$halloween_store_product_price = array('29.99','29.99','29.99','29.99','29.99');
	$halloween_store_product_regular_price = array('29.99','29.99','29.99','29.99','29.99');
	$halloween_store_product_sale_price = array('29.99','29.99','29.99','29.99','29.99');
	
	update_post_meta( $halloween_store_uqpost_id, '_regular_price', $halloween_store_product_regular_price[$halloween_store_n-1] );
	update_post_meta( $halloween_store_uqpost_id, '_price', $halloween_store_product_price[$halloween_store_n-1] );
	update_post_meta( $halloween_store_uqpost_id, '_sale_price', $halloween_store_product_sale_price[$halloween_store_n-1] );
	array_push( $halloween_store_product_ids,  $halloween_store_uqpost_id );

	// Now replace meta w/ new updated value array
	$halloween_store_image_url = get_template_directory_uri().'/assets/images/product/'.$halloween_store_product_cats.'/' . str_replace(' ', '_', strtolower($halloween_store_product_title)).'.png';
	$halloween_store_image_name  = $halloween_store_product_title.'.png';
	$halloween_store_upload_dir = wp_upload_dir();
	// Set upload folder
	$halloween_store_image_data = file_get_contents(esc_url($halloween_store_image_url));
	// Get image data
	$unique_file_name = wp_unique_filename($halloween_store_upload_dir['path'], $halloween_store_image_name);
	// Generate unique name
	$halloween_store_filename = basename($unique_file_name);
	// Create image file name
	// Check folder permission and define file location
	if (wp_mkdir_p($halloween_store_upload_dir['path'])) {
	$halloween_store_file = $halloween_store_upload_dir['path'].'/'.$halloween_store_filename;
	} else {
	$halloween_store_file = $halloween_store_upload_dir['basedir'].'/'.$halloween_store_filename;
	}
	
	file_put_contents($halloween_store_file, $halloween_store_image_data);
	// Check image file type
	$wp_filetype = wp_check_filetype($halloween_store_filename, null);
	// Set attachment data
	$attachment = array(
	'post_mime_type' => $wp_filetype['type'],
	'post_title'     => sanitize_file_name($halloween_store_filename),
	'post_type'      => 'product',
	'post_status'    => 'inherit',
	);

	// Create the attachment
	$halloween_store_attach_id = wp_insert_attachment($attachment, $halloween_store_file, $halloween_store_uqpost_id);

	// Define attachment metadata
	$attach_data = wp_generate_attachment_metadata($halloween_store_attach_id, $halloween_store_file);

	// Assign metadata to attachment
	wp_update_attachment_metadata($halloween_store_attach_id, $attach_data);
	if ( count( $halloween_store_product_image_gallery ) < 3 ) {
		array_push( $halloween_store_product_image_gallery, $halloween_store_attach_id );
	}
	// // And finally assign featured image to post
	set_post_thumbnail($halloween_store_uqpost_id, $halloween_store_attach_id);
	++$halloween_store_n;
	}
	// Create product END
	++$halloween_store_k;
	}
	// Add Gallery in first simple product and second variable product START
	$halloween_store_product_image_gallery = implode( ',', $halloween_store_product_image_gallery );
	foreach ( $halloween_store_product_ids as $halloween_store_product_id ) {
	update_post_meta( $halloween_store_product_id, 'halloween_store_product_image_gallery', $halloween_store_product_image_gallery );
	}

	/* Create Menu */
            $halloween_store_menuname  = 'Main Menus';
            $halloween_store_location  = 'main-menu';

            $halloween_store_menu = wp_get_nav_menu_object( $halloween_store_menuname );

            if ( ! $halloween_store_menu ) {
            $halloween_store_menu_id = wp_create_nav_menu( $halloween_store_menuname );

           // Home Page 
			wp_update_nav_menu_item( $halloween_store_menu_id, 0, array(
				'menu-item-title'     => __( 'Home', 'halloween-store' ),
				'menu-item-url'       => home_url( '/' ),
				'menu-item-type'      => 'custom',
				'menu-item-status'    => 'publish',
			) );

			// About Page 
			$halloween_store_about_id = wp_insert_post( array(
			'post_type'   => 'page',
			'post_content' => 'We are committed to providing reliable, professional, and result-oriented solutions tailored to meet individual needs. Our goal is to empower people with the right guidance, knowledge, and support to help them make informed decisions for a better future. <br><br> Our mission is to deliver high-quality services with honesty, transparency, and dedication. We focus on understanding client requirements and offering practical solutions that create long-term value. <br><br> With a client-centric approach, experienced professionals, and a commitment to excellence, we ensure every individual receives the attention and guidance they deserve. We believe in building trust through quality service and consistent results.',
			'post_title'  => 'About Us',
			'post_status' => 'publish',
			) );

			if ( $halloween_store_about_id ) {
			wp_update_nav_menu_item( $halloween_store_menu_id, 0, array(
			'menu-item-title'     => 'About Us',
			'menu-item-object'    => 'page',
			'menu-item-object-id' => $halloween_store_about_id,
			'menu-item-type'      => 'post_type',
			'menu-item-status'    => 'publish',
			) );
			}

			// Services Page 
			$halloween_store_about_id = wp_insert_post( array(
			'post_type'   => 'page',
			'post_content' => 'We are committed to providing reliable, professional, and result-oriented solutions tailored to meet individual needs. Our goal is to empower people with the right guidance, knowledge, and support to help them make informed decisions for a better future. <br><br> Our mission is to deliver high-quality services with honesty, transparency, and dedication. We focus on understanding client requirements and offering practical solutions that create long-term value. <br><br> With a client-centric approach, experienced professionals, and a commitment to excellence, we ensure every individual receives the attention and guidance they deserve. We believe in building trust through quality service and consistent results.',
			'post_title'  => 'Services',
			'post_status' => 'publish',
			) );

			if ( $halloween_store_about_id ) {
			wp_update_nav_menu_item( $halloween_store_menu_id, 0, array(
			'menu-item-title'     => 'Services',
			'menu-item-object'    => 'page',
			'menu-item-object-id' => $halloween_store_about_id,
			'menu-item-type'      => 'post_type',
			'menu-item-status'    => 'publish',
			) );
			}

        // CREATE SHOP PAGE
                $halloween_store_about_title = 'Shop';
                $halloween_store_about_content = 'Lorem ipsum dolor sit amet...';

                $shop_page = get_page_by_path('shop');
                if ( !$shop_page ) {
                    $halloween_store_about = array(
                        'post_type'   => 'page',
                        'post_title'  => $halloween_store_about_title,
                        'post_content'=> $halloween_store_about_content,
                        'post_status' => 'publish',
                        'post_author' => 1,
                        'post_name'   => 'shop' 
                        );
                        $halloween_store_about_id = wp_insert_post($halloween_store_about);
                    } else {
                        $halloween_store_about_id = $shop_page->ID;
                    }

                    wp_update_nav_menu_item($halloween_store_menu_id, 0, array(
                        'menu-item-title'   => __('Shop', 'halloween-store'),
                        'menu-item-classes' => 'shop',
                        'menu-item-object-id' => $halloween_store_about_id,
                        'menu-item-object'  => 'page',
                        'menu-item-type'    => 'post_type',
                        'menu-item-status'  => 'publish'
                    ));

			 // Create Blog Page 
            $halloween_store_blog_page_title = 'Blog';

             $halloween_store_blog_page_query = new WP_Query(array(
            'post_type'      => 'page',
            'name'           => sanitize_title($halloween_store_blog_page_title),
            'post_status'    => 'publish',
            'posts_per_page' => 1
            ));
            if (!$halloween_store_blog_page_query->have_posts()) {
            $halloween_store_blog_page = array(
            'post_type'   => 'page',
            'post_title'  => $halloween_store_blog_page_title,
            'post_status' => 'publish',
            'post_author' => 1,
            );
            $halloween_store_blog_page_id = wp_insert_post($halloween_store_blog_page);
            update_option('page_for_posts', $halloween_store_blog_page_id);

            wp_update_nav_menu_item($halloween_store_menu_id, 0, array(
            'menu-item-title'      => __('Blog', 'halloween-store'),
            'menu-item-url'        => get_permalink($halloween_store_blog_page_id),
            'menu-item-status'     => 'publish',
            'menu-item-object-id'  => $halloween_store_blog_page_id,
            'menu-item-object'     => 'page',
            'menu-item-type'       => 'post_type',
            ));
            }		
            
			/* Assign Menu Location */
			$halloween_store_locations = get_theme_mod( 'nav_menu_locations', array() );
			$halloween_store_locations[ $halloween_store_location ] = $halloween_store_menu_id;
			set_theme_mod( 'nav_menu_locations', $halloween_store_locations );
		}
    }

}
 